-- $Id$
--

-- Delete schema
DROP TABLE Related;

DROP TABLE Comments;
DROP SEQUENCE Comment_cid_seq;

DROP TABLE Upload;
DROP SEQUENCE Upload_upid_seq;

DROP TABLE SourcePackage;
DROP SEQUENCE SourcePackage_sid_seq;

DROP TABLE Users;
DROP SEQUENCE user_uid_seq;

-- sequence: the true way of "auto_increment" 

CREATE SEQUENCE user_uid_seq;

CREATE TABLE Users (
	usid		INTEGER		NOT NULL DEFAULT nextval('user_uid_seq'),
	password 	VARCHAR(64)	NOT NULL,
	email		VARCHAR(64)	NOT NULL UNIQUE,
	gnupgid		VARCHAR(8),
	accesslevel 	VARCHAR(12) 	NOT NULL CHECK (accesslevel IN ('Contributor', 'Reviewer', 'Admin')) DEFAULT 'Contributor',
	PRIMARY KEY(usid)
);

CREATE SEQUENCE SourcePackage_sid_seq;

CREATE TABLE SourcePackage (
	sid		INTEGER		NOT NULL DEFAULT nextval('SourcePackage_sid_seq'),
	name		VARCHAR(64)	NOT NULL UNIQUE,
	isNew		BOOLEAN		NOT NULL DEFAULT FALSE,
	isInArchive	BOOLEAN		NOT NULL DEFAULT FALSE,
	PRIMARY KEY(sid)
);

CREATE SEQUENCE Upload_upid_seq;

CREATE TABLE Upload (
	upid		INTEGER 	NOT NULL DEFAULT nextval('Upload_upid_seq'),
	dateOfUpload	TIMESTAMP	NOT NULL DEFAULT now(),
	sid		INTEGER		NOT NULL REFERENCES SourcePackage(sid) ON DELETE CASCADE,
	usid		INTEGER		NOT NULL REFERENCES Users(usid) ON DELETE RESTRICT,
	isArchived	BOOLEAN		NOT NULL DEFAULT FALSE,
	PRIMARY KEY(upid)
);

CREATE SEQUENCE Comment_cid_seq;

CREATE TABLE Comments (
	cid		INTEGER 	NOT NULL DEFAULT nextval('Comment_cid_seq'),
	upid		INTEGER		NOT NULL REFERENCES Upload(upid) ON DELETE RESTRICT,
	usid		INTEGER 	NOT NULL REFERENCES Users(usid) ON DELETE RESTRICT,
	text		VARCHAR(4096),
	dateOfComment	TIMESTAMP	NOT NULL DEFAULT now(),
	isAdvocating	BOOLEAN		NOT NULL DEFAULT FALSE,
	PRIMARY KEY(cid)
);

