# Copyright (c) 2005, Reinhard Tartler, Stefan Potyra
#
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
#     * Redistributions of source code must retain the above copyright notice,
#     this list of conditions and the following disclaimer.
#
#     * Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in the
#     documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#

import os, sys
from glob import glob
from mod_python import psp
from mod_python import util

from Config import Config
from Uploads import basedir

def _getdebdiff(cfg, c, upid1, upid2):
	p = [ cfg.getIncomingDir() + basedir(c, upid1), cfg.getIncomingDir() + basedir(c, upid2) ]
	cmd = 'nice /usr/bin/debdiff %s %s | filterdiff -x "*/config.sub" | filterdiff -x "*/config.guess"' % (glob(p[0]+'*.dsc')[0], glob(p[1]+'*.dsc')[0])
	s = os.popen(cmd)
	return s.read()
	
def index(req):
	fs = util.FieldStorage(req)
	if (not fs.has_key('upid1')) and (not fs.has_key('upid2')):
		return "please select packages to be debdiffed"
	# set content type to text plain, otherwise email-addresses in debdiffs get lost
	req.content_type = "text/plain"

	cfg = Config(req)
	c = cfg.getConnection()
	debdiff = _getdebdiff(cfg, c, int(fs['upid1']), int(fs['upid2']))
	return debdiff


