# Copyright (C) 2008 Siegfried-Angel Gevatter Pujals <rainct@ubuntu.com>
#
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
# 
#     * Redistributions of source code must retain the above copyright notice,
#     this list of conditions and the following disclaimer.
# 
#     * Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in the
#     documentation and/or other materials provided with the distribution.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
# DESCRIPTION:
# This page takes a package name as argument and provides a static URL
# that always refers to the latest .dsc file from that package.
#

import os
import sys

from common import *
from Config import Config
from Uploads import basedir

def index(req):
	
	# Force content type
	req.content_type = "text/plain"
	
	if not req.form.has_key('package') or not req.form['package']:
		return 'No package selected.'
	
	if not is_format_package_name(req.form['package']):
		return 'Not a valid package name.'
	
	#real_dsc_file = False
	#if req.form['package'].endswith('.dsc'):
	#	req.form['package'] = req.form['package'][:-4]
	#	real_dsc_file = True
	
	cfg = Config(req)
	db = cfg.getConnection()
		
	sql = """
		SELECT upid FROM upload u
		INNER JOIN sourcepackage s
		ON u.sid=s.sid WHERE s.name='%s' 
		ORDER BY u.dateofupload DESC LIMIT 1
		""" % "".join(req.form['package'])
	
	result = db.query(sql)
	if result.ntuples() == 1:
		upid = int(result.dictresult()[0]['upid'])
		del result
	else:
		return 'Package "%s" is not in our database.' % req.form['package']
	
	directory_name = basedir(db, upid)
	upload_directory = os.path.join(cfg.getIncomingDir(), directory_name)
	dsc_file = None
	
	for file in os.listdir(upload_directory):
		if file.endswith('.dsc'):
			dsc_file = os.path.join(upload_directory, file)
			break
	
	if not dsc_file:
		return 'Invalid upload.'
	
	if req.form.has_key('url'):
		return 'http://' + req.hostname + os.path.join(cfg.getBaseUrlPath(), directory_name, file)
	
	#if real_dsc_file:
	#	from mod_python import util
	#	util.redirect(req, os.path.join(cfg.getBaseUrlPath(), directory_name, file))
	
	return open(dsc_file, 'r').read()
