# Copyright (c) 2005, Reinhard Tartler, Stefan Potyra
# Copyright (c) 2008 Siegfried-Angel Gevatter Pujals <rainct@ubuntu.com>
#
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
#     * Redistributions of source code must retain the above copyright notice,
#     this list of conditions and the following disclaimer.
#
#     * Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in the
#     documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#

# encrypting the password to users

import os, sys
from mod_python import util
from Config import Config
from alter_user import show_password

def no_account(email):
	return "There is no REVU account for %s, yet." % str(email)

def index(req):
	fs = util.FieldStorage(req)
	if not fs.has_key('email'):
		return "Please specify an email address."
	cfg = Config(req)
	c = cfg.getConnection()
	email=fs['email']
	pw = show_password(c, email)
	if pw is None:
		return no_account(email)
	else:
		(stdin, stdout) = os.popen2('%s/scripts/revu-key encrypt %s' % ('/srv/revu-production', email))
		stdin.write("%s" % show_password(c, email))
		stdin.close()
		s = stdout.read()
		return """
To decrypt your password, copy the following into your shell:

gpg -d <<EOT; echo
%s
EOT
""" % s
