# Copyright (c) 2005, Reinhard Tartler, Stefan Potyra 
#
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
# 
#     * Redistributions of source code must retain the above copyright notice,
#     this list of conditions and the following disclaimer.
# 
#     * Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in the
#     documentation and/or other materials provided with the distribution.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#


from Config import Config

def getPackageName(c, upid):
	sql = """SELECT name 
		 FROM SourcePackage sp JOIN Upload up
		                       ON sp.sid = up.sid
		 WHERE up.upid = '%d'
	      """ % int(upid)
	r = c.query(sql)
	if r.ntuples() == 1:
		return r.dictresult()[0]["name"]

def isNew(c, sid):
	sql = "SELECT isNew FROM SourcePackage WHERE sid = %d" % sid
	r = c.query(sql)
	if r.ntuples() == 1:
		b = r.dictresult()[0]["isnew"]
		if b == 't':
			return True
		else:
			return False

def isInArchive(c, sid):
	sql = "SELECT isInArchive FROM SourcePackage WHERE sid = %d" % sid
	r = c.query(sql)
	if r.ntuples() == 1:
		b = r.dictresult()[0]["isinarchive"]
		if b == 't':
			return True
		else:
			return False

# small 'testcase' for package no 1

if __name__ == '__main__':
	cfg = Config()
	c = cfg.getConnection()
	name = getPackageName(c,4)
	print name
