# Copyright (c) 2005, Reinhard Tartler, Stefan Potyra 
#
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
# 
#     * Redistributions of source code must retain the above copyright notice,
#     this list of conditions and the following disclaimer.
# 
#     * Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in the
#     documentation and/or other materials provided with the distribution.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#

import Connection
from common import sanitize_username

class User:
	def __init__(self, email, password, dbconnection):
		self.email = email
		self.password = password
		self.dbcon = dbconnection

		if (self.email is None) or (self.password is None) or (len(self.password) < 4):
			self.is_authed = False
			return

		sql = """SELECT email, usid, accesslevel FROM Users 
			 WHERE email='%s' AND password='%s'
		      """ % (sanitize_username(self.email), sanitize_username(self.password))
		r = self.dbcon.query(sql)
		if r.ntuples() == 1:
			self.usid = r.dictresult()[0]["usid"]
			self.accesslevel = r.dictresult()[0]["accesslevel"]
			self.is_authed = True
		else:
			self.is_authed = False

	def isAuthed(self):
		return self.is_authed
