#!/usr/bin/python
#
# Copyright (c) 2005, Reinhard Tartler, Stefan Potyra 
#
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
# 
#     * Redistributions of source code must retain the above copyright notice,
#     this list of conditions and the following disclaimer.
# 
#     * Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in the
#     documentation and/or other materials provided with the distribution.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#

from optparse import OptionParser
from Config import Config


def alter_NEW(c, package, NEW):
	n = ''
	if NEW == 'f':
		n = 'not'
        print "Marking package %s as %s NEW" % (package, n)
        sql = "UPDATE SourcePackage SET isNew = '%s' WHERE name = '%s'" % (NEW, package)
        c.query(sql)

def alter_archive(c, package, archive):
	n = ''
	if archive == 'f':
		n = 'not'
	else:
		n = 'already'
        print "Marking package %s as %s in Archive" % (package, n)
        sql = "UPDATE SourcePackage SET isInArchive = '%s' WHERE name = '%s'" % (archive, package)
        c.query(sql)

if __name__ == '__main__':
        usage = "usage: %prog [options]"
        parser = OptionParser(usage)
        parser.add_option("-p", "--package", dest="package",
                          help="Name of sourcepackage to alter")
        parser.add_option("-N", "--NEW", dest="NEW", type="choice",
                          choices = ['t', 'f'],
                          help="mark Package as NEW")
        parser.add_option("-a", "--archive", dest="archive",
	                  choices = ['t', 'f'],
                          help="mark Package as already in Archive")

        (options, args) = parser.parse_args()
        if options.package is None:
                parser.print_help()
                parser.error("you must specify a source package to alter")

	cfg = Config()
        c = cfg.getConnection()
        if options.NEW is not None:
                alter_NEW(c, options.package, options.NEW)
        if options.archive is not None:
                alter_archive(c, options.package, options.archive)
