#!/bin/sh

# please note: SOURCE and DEST *must* be on the same file system.
SOURCE=/srv/uploads/ftp/incoming
DEST=/srv/uploads
REVUUSER=revu1

for i in ${SOURCE}/*; do
	if [ -e "${i}" ]; then
		# little hack: vsftpd on spooky doesn't allow files to be
		# overwritten. Hence we move them out of way on the same file
		# system (which allows an upload in progress to finish)
		# Then a later upload can easily replace files.
		mv ${i} ${DEST}/
		NAME=$(basename ${i})
		chmod g+rw "${DEST}/${NAME}" || echo "chmod failed for ${DEST}/${NAME}"
		chown ${REVUUSER} "${DEST}/${NAME}" || echo "chown failed for ${DEST}/${NAME}"
	fi
done

# process uplolads
su ${REVUUSER} -c /srv/revu-production/scripts/process_uploads.sh
