#!/usr/bin/python
#
# Copyright (c) 2005, Reinhard Tartler, Stefan Potyra 
#
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
# 
#     * Redistributions of source code must retain the above copyright notice,
#     this list of conditions and the following disclaimer.
# 
#     * Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in the
#     documentation and/or other materials provided with the distribution.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#

#from Connection import Connection
from Config import Config
from Uploads import nuke_upload
from Uploads import nuke_upload_rec

if __name__ == '__main__':
	from optparse import OptionParser
        usage = "usage: %prog [options]"
        parser = OptionParser(usage)
	parser.add_option("-u", "--upload", dest="upid",
			  help="upload to nuke from database")
	parser.add_option("-r", dest="rek", action="store_true", default=False,			
			  help="delete all uploads with the same sourcepackage")

        (options, args) = parser.parse_args()
        if options.upid is None:
                parser.print_help()
                parser.error("you must specify an upload id to nuke")

	cfg = Config()
	c =  cfg.getConnection()
	upid = int(options.upid)

	if options.rek:
		print "nuking all uploads regarding upid: %d" % upid
		nuke_upload_rec(cfg, c, upid)
		print "nuked all uploads regarding upid %d from database" % upid
		print "now remove corresponding dirs manually"		
	else:
		nuke_upload(cfg, c, upid)
		print "upload with upid %d is nuked from database." % upid
		print "now remove corresponding dirs manually"
		
