#!/bin/sh

set +e 

UPLOAD_QUEUE=/srv/uploads
KEYRING=/srv/revu-production/uploaders.gpg
INCOMING=/var/revu/revu1-incoming
PATH=$PATH:/srv/revu-production/scripts
HOOKDIR=/srv/revu-production/hook.d

cd $UPLOAD_QUEUE

WORKLIST=$(find $UPLOAD_QUEUE -maxdepth 1 -name \*_source.changes)
for changes in $WORKLIST; do
	if dscverify --keyring $KEYRING $changes ; then
		echo ACCEPTED $changes
		FILES=$(query-changes.py -c $changes -f | tr '\n' ' ') || echo "no files"
		UPLOADER=$(query-changes.py -c $changes -u) || echo "no uploader"
		PACKAGE=$(query-changes.py -c $changes -n) || echo "no package"
		DIR=${INCOMING}/${PACKAGE}-$(date +%y%m%d%H%M) || echo "no dir" 
		echo Accepting upload $PACKAGE from $UPLOADER
		mkdir -m 775 $DIR
		for file in $FILES; do
			SANEFILE="${UPLOAD_QUEUE}/$(basename ${file})"
			chmod 664 "${SANEFILE}"
			chgrp revu "${SANEFILE}"
			mv "${SANEFILE}" $DIR
		done
		register_upload.py $changes || echo "register_upload"
		check-package $changes || echo  "check-package"
		mv $changes $DIR || echo "mv changes dir"
		run-parts --arg=${DIR} ${HOOKDIR} || echo "run-parts"
	else
		echo $changes could not be processed. moving to rejected
		mv $changes ${UPLOAD_QUEUE}/rejected
	fi
done
