# Copyright (c) 2007, Andrew Mitchell
#
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
# 
#     * Redistributions of source code must retain the above copyright notice,
#     this list of conditions and the following disclaimer.
# 
#     * Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in the
#     documentation and/or other materials provided with the distribution.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#


import os, sys, string
from mod_python import psp
from mod_python import util
from mod_python.Session import Session

from Config import Config
import User
from Package import *
from Uploads import *
from Comments import *
from stat import *


def uploads(c, user, packages):
    s = ''
    if packages is None:
	return ''
    for pkg in packages:
        s += "<tr><td>%s</td><td>%s</td><td>%s</td></tr>" % (pkg['upid'], pkg['name'], pkg['to_char'])
    return s
    

def _uploadpage(req, c, user, packages):
    vars = { 'email': user,
             'uploads':uploads(c, user, packages)
             }
    tmpl = cfg.getTemplatesPath('uploads.html')
    m = psp.PSP(req, tmpl, vars=vars)
    return m

def index(req):
    """Called by default from apache
    """
    
    fs = util.FieldStorage(req)
    global cfg
    cfg = Config(req)
    c = cfg.getConnection()
    
    upid = None
    
    if fs.has_key('user'):
	
	user = fs['user']
	user = [x for x in user if x in string.ascii_letters + "@+-." + string.digits ]
	user = "".join(user)

        sql = """ SELECT upid, SourcePackage.name, to_char(dateofupload, 'Month DD  HH24:MI') 
		  FROM Upload 
		  INNER JOIN Users 
			ON (Upload.usid=Users.usid) 
		  INNER JOIN SourcePackage 
			ON (Upload.sid=SourcePackage.sid) 
		  WHERE Users.email='%s' 
		  ORDER by SourcePackage.name;
	      """ % user
        r = c.query(sql)
        packages = r.dictresult()
    else:
        packages = []
        return "Must select user"
    
    return _uploadpage(req, c, user, packages)
